"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cut = cut;

var _dom = require("@testing-library/dom");

var _utils = require("../utils");

function cut(options) {
  var _options$document, _doc$activeElement;

  const doc = (_options$document = options == null ? void 0 : options.document) != null ? _options$document : document;
  const target = (_doc$activeElement = doc.activeElement) != null ? _doc$activeElement :
  /* istanbul ignore next */
  doc.body;
  const clipboardData = (0, _utils.copySelection)(target);

  if (clipboardData.items.length === 0) {
    return;
  }

  _dom.fireEvent.cut(target, {
    clipboardData
  });

  if ((0, _utils.isEditable)(target)) {
    var _prepareInput;

    (_prepareInput = (0, _utils.prepareInput)('', target, 'deleteByCut')) == null ? void 0 : _prepareInput.commit();
  }

  return options != null && options.writeToClipboard ? (0, _utils.writeDataTransferToClipboard)(doc, clipboardData).then(() => clipboardData) : clipboardData;
}