"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.paste = paste;

var _dom = require("@testing-library/dom");

var _utils = require("../utils");

function paste(clipboardData, options) {
  var _options$document, _doc$activeElement;

  const doc = (_options$document = options == null ? void 0 : options.document) != null ? _options$document : document;
  const target = (_doc$activeElement = doc.activeElement) != null ? _doc$activeElement :
  /* istanbul ignore next */
  doc.body;
  const data = typeof clipboardData === 'string' ? getClipboardDataFromString(clipboardData) : clipboardData;
  return data ? pasteImpl(target, data) : (0, _utils.readDataTransferFromClipboard)(doc).then(dt => pasteImpl(target, dt), () => {
    throw new Error('`userEvent.paste()` without `clipboardData` requires the `ClipboardAPI` to be available.');
  });
}

function pasteImpl(target, clipboardData) {
  _dom.fireEvent.paste(target, {
    clipboardData
  });

  if ((0, _utils.isEditable)(target)) {
    const data = clipboardData.getData('text').substr(0, (0, _utils.getSpaceUntilMaxLength)(target));

    if (data) {
      var _prepareInput;

      (_prepareInput = (0, _utils.prepareInput)(data, target, 'insertFromPaste')) == null ? void 0 : _prepareInput.commit();
    }
  }
}

function getClipboardDataFromString(text) {
  const dt = (0, _utils.createDataTransfer)();
  dt.setData('text', text);
  return dt;
}